// Audio helper functions
void waveInit()
{
	waveform1.arbitraryWaveform(customWaveform, 172.0);
	waveform1.frequency(440);
	waveform1.amplitude(0);
	current_waveform = WAVEFORM_SINE;
	setWaveform(false);
	waveform1.begin(current_waveform);
}

void newPitch()
{
	notenum = rootnote + *(scalePointer + (rawNote % scaleSize)) - 1 + ((rawNote / scaleSize) * 12);
	bendNote = notenum - 9;

	if (lastMidiNote != notenum && currentScale < numScales) // not in free pitch / theremin mode
	{
		sendNote(notenum);
		noteFreq = note[notenum - 9];
		setFrequency(noteFreq);
	}
}

void setFrequency(float freq)
{
	AudioNoInterrupts();
	waveform1.frequency(freq);
	AudioInterrupts();
}

void setAmplitude(float gain)
{
	if (settings.isMuted)
		gain = 0;
	AudioNoInterrupts();
	waveform1.amplitude(gain);
	AudioInterrupts();
}

void setWaveform(bool alert)
{
	if (current_waveform == 0)
	{
		maxGain = 0.3;
		waveMakeUp = 15;
	}
	else
	{
		maxGain = 1;
		waveMakeUp = 1;
	}
	AudioNoInterrupts();
	waveform1.begin(current_waveform);
	AudioInterrupts();
	voiceName = voiceNames[current_waveform];
	if (alert)
		showAlert(voiceName, 400, 0, 0, 1);
}

void resetPitch()
{
	noteFreq = note[bendNote];
	AudioNoInterrupts();
	waveform1.frequency(noteFreq);
	AudioInterrupts();
}


