void changeMode(byte mde, bool alert)
{
	mode = mde;

	switch (mde)
	{
	case 0: // play
		if (mode != lastMode)
		{
			param = lastParam[0];
			lastMode = mode;
		}

		adjustValuePtr[0] = &current_waveform;
		adjustIncrement[0] = 1;
		lowerLimit[0] = 0;
		upperLimit[0] = 8;

		adjustValuePtr[1] = &rootnote;
		adjustIncrement[1] = 1;
		lowerLimit[1] = 20;
		upperLimit[1] = 100;

		adjustValuePtr[2] = &currentScale;
		adjustIncrement[2] = 1;
		lowerLimit[2] = 0;
		upperLimit[2] = numScales;

		numParams = 3;

		modeName = "1.PLAY";
		paramName[0] = "VOICE";
		paramVal[0] = &voiceName;
		paramName[1] = "ROOT";
		paramVal[1] = &rootName;
		paramName[2] = "SCALE";
		paramVal[2] = &scaleName;
		break;
	case 1: // song
		if (mode != lastMode)
		{
			param = lastParam[1];
			lastMode = mode;
		}

		adjustValuePtr[0] = &song;
		adjustIncrement[0] = 1;
		lowerLimit[0] = 0;
		upperLimit[0] = 19;

		adjustValuePtr[1] = &part;
		adjustIncrement[1] = 1;
		lowerLimit[1] = 0;
		upperLimit[1] = 9;

		numParams = 2;
		modeName = "2.SONG";
		paramName[0] = "SONG";
		setSong();
		paramName[1] = "PART";
		setPart();
		paramName[2] = "      ->";
		tempVal[2] = "NOT LOADED!";
		paramVal[2] = &tempVal[2];
		break;
	case 2: // setup
		numParams = 13;
		if (mode != lastMode)
		{
			param = lastParam[2];
			lastMode = mode;
		}
		modeName = "3.SETUP";
		switch (param / 3)
		{
		case 0:
			adjustValuePtr[0] = &settings.pitchTofIsRight;
			adjustIncrement[0] = 1;
			lowerLimit[0] = 0;
			upperLimit[0] = 1;

			adjustValuePtr[1] = &settings.pitchMaxMM;
			adjustIncrement[1] = 1;
			lowerLimit[1] = 50;
			upperLimit[1] = 500;

			adjustValuePtr[2] = &settings.volMaxMM;
			adjustIncrement[2] = 1;
			lowerLimit[2] = 50;
			upperLimit[2] = 500;

			paramName[0] = "PITCH"; // pitch side
			paramVal[0] = &side[settings.pitchTofIsRight];
			paramName[1] = "P MAX";
			setPitchMaxMM();
			paramName[2] = "V MAX";
			setVolMaxMM();
			break;
		case 1:
			adjustValuePtr[0] = &settings.pitchNumSteps;
			adjustIncrement[0] = 1;
			lowerLimit[0] = 1;
			upperLimit[0] = 29;

			adjustValuePtr[1] = &settings.pitchMidiChan;
			adjustIncrement[1] = 1;
			lowerLimit[1] = 1;
			upperLimit[1] = 16;

			adjustValuePtr[2] = &settings.pitchMidiCC;
			adjustIncrement[2] = 1;
			lowerLimit[2] = 0;
			upperLimit[2] = 127;

			paramName[0] = "STEPS";
			setPitchNumSteps();
			paramName[1] = "P CHN";
			setPitchChn();
			paramName[2] = "P CC";
			setPitchCC();
			break;
		case 2:
			adjustValuePtr[0] = &settings.volMidiChan;
			adjustIncrement[0] = 1;
			lowerLimit[0] = 1;
			upperLimit[0] = 16;

			adjustValuePtr[1] = &settings.volMidiCC;
			adjustIncrement[1] = 1;
			lowerLimit[1] = 0;
			upperLimit[1] = 127;

			adjustValuePtr[2] = &settings.ledMode;
			adjustIncrement[2] = 1;
			lowerLimit[2] = 0;
			upperLimit[2] = 2;

			paramName[0] = "V CHN"; // pitch side
			setVolChn();
			paramName[1] = "V CC";
			setVolCC();
			paramName[2] = "LEDS";
			setLedMode();
			break;
		case 3:
			adjustValuePtr[0] = &settings.bendRange;
			adjustIncrement[0] = 1;
			lowerLimit[0] = 1;
			upperLimit[0] = 12;

			adjustValuePtr[1] = &settings.pitchIsInverted;
			adjustIncrement[1] = 1;
			lowerLimit[1] = 0;
			upperLimit[1] = 1;

			adjustValuePtr[2] = &settings.volIsInverted;
			adjustIncrement[2] = 1;
			lowerLimit[2] = 0;
			upperLimit[2] = 1;

			paramName[0] = "P BND"; // pitch side
			setPitchBendRange();
			paramName[1] = "P INV"; // invert pitch range
			setPInverted();
			paramName[2] = "V INV"; // invert vol range
			setVInverted();
			break;

		case 4:
			adjustValuePtr[0] = &settings.isMuted;
			adjustIncrement[0] = 1;
			lowerLimit[0] = 0;
			upperLimit[0] = 1;

			paramName[0] = "MUTE"; // pitch side
			setMuted();
			paramName[1] = "     ";
			paramName[2] = "Hold [F2] To Save";
			break;
		}

		break;
	case 10: // save
		if (mode != lastMode)
		{
			param = lastParam[3];
			lastMode = mode;
		}

		adjustValuePtr[0] = &songToSave;
		adjustIncrement[0] = 1;
		lowerLimit[0] = 0;
		upperLimit[0] = 19;

		adjustValuePtr[1] = &partToSave;
		adjustIncrement[1] = 1;
		lowerLimit[1] = 0;
		upperLimit[1] = 9;

		numParams = 2;
		modeName = "SAVE";
		paramName[0] = "SONG";
		setSongToSave();
		paramName[1] = "PART";
		setPartToSave();
		paramName[2] = "Hold [F2] To Save";
		paramVal[2] = &blank;
		break;

	case 11: // save confirm
		numParams = 1;
		param = 2; // we're not showing param highlight, but we don't want text color to be inverted
		lastMode = 11;

		modeName = "OVERWRITE?";
		paramName[0] = "Press [F1] to CANCEL";
		paramVal[0] = &blank;
		paramName[1] = "Press [F2] to SAVE";
		paramVal[1] = &blank;
		paramName[2] = "";
		paramVal[2] = &blank;
		break;
	}

	if (!alert)
		return;

	switch (mode) // need individual cases here because the box widths are not the same
	{
	case 0:
		showAlert("1.PLAY", 400, 0, 103, 1);
		break;
	case 1:
		showAlert("2.SONG", 400, 0, 113, 1);
		break;
	case 2:
		showAlert("3.SETUP", 400, 0, 126, 1);
		break;
	case 10:
		showAlert("SAVE", 400, 0, 84, 1);
		break;
	case 11:
		showAlert("CONFIRM", 400, 0, 128, 1);
		break;
	}
}

