void updatePots()
{
	for (int i = 0; i < 2; i++)
	{
		tempPotVal[i] = analogRead(0 + i);
		if (abs(tempPotVal[i] - potVal[i]) > 50)
		{
			potLocked[i] = 100; // stay unlocked for 100 calls to updatePots()
		}
		if (potLocked[i] != 0)
		{
			potVal[i] = tempPotVal[i];
			potLocked[i]--;
		}
	}
}

void lockAllPots()
{
	for (int i = 0; i < 2; i++)
		potLocked[i] = 0;
}

void handlePots()
{
	if (potLocked[0] > 0)
	{
		if (F1)
		{
			ignoreF1Released = true;
			reverbLevel = (float)potVal[0] / 4096.0;
			setReverb(reverbLevel);
			String verb = "Rev: " + String(int(reverbLevel * 100));
			showAlert(verb, 400, 0, 0, 1);
		}
		else if (F2)
		{
			ignoreF2Released = true;
		}
		else
		{
			float vol = (float)potVal[0] / 4096.0;
			masterOutputAmp.gain(vol);
			volume = byte(vol * 100);
			String vlm = "Vol: " + String(volume);
			showAlert(vlm, 400, 0, 0, 1);
		}
	}

	if (potLocked[1] > 0)
	{
		static byte lastScale = 0;

		*adjustValuePtr[param % 3] = map(potVal[1], 0, 4096.0, lowerLimit[param % 3], upperLimit[param % 3]);
		// it shouldn't be possible to go outside the upper and lower limits, but just in case
		constrain(*adjustValuePtr[param % 3], lowerLimit[param % 3], upperLimit[param % 3]);

		// check if a function needs to be called
		checkButtonFunctions();
	}
}

void setReverb(float verbLevel)
{
	mixer1.gain(0, 1.0 - verbLevel);
	mixer1.gain(1, verbLevel);
	reverbMakeupAmp.gain(1 + (verbLevel * 1.5));
}
